<id>
vAdminSecurity DNS
</id>

<version>
0.92
</version>

<mod info>
This mod implements a DNS security check for admin actions (those you need to give a password for), providing additional security.
</mod info>

<author>
Valodim
</author>

<homepage>
mugenguild.com
</homepage>



<edit file>
$sourcedir/Load.php
</edit file>


<search for>
		'passwd' => isset($user_settings['passwd']) ? $user_settings['passwd'] : '',
</search for>

<add after>
		'securityDNS' => isset($user_settings['securityDNS']) ? $user_settings['securityDNS'] : '',
</add after>


<search for>
			mem.birthdate, mem.ICQ, mem.AIM, mem.YIM, mem.MSN, mem.posts, mem.lastLogin, mem.karmaGood,
</search for>

<add after>
                        mem.securityDNS,
</add after>



<edit file>
$sourcedir/Security.php
</edit file>


<search for>
	if (!empty($modSettings['securityDisable']) || (!empty($_SESSION['admin_time']) && $_SESSION['admin_time'] + 3600 >= time()))
</search for>

<add before>
	// vAdminSecurity DNS mod, go! just check for the dns and don't allow unauthorized user to enter
	if(!empty($modSettings['vdns_enable'])) {
		// no proxies allowed here!
		if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
			fatal_lang_error('dns_noprox');
		// pass through
		$error = '';
		// do we even have a security dns here?
		if(empty($user_info['securityDNS']))
                        $error = 'dns_notset';
		// if the remote address does not equal the dns, kill.
		if($_SERVER['REMOTE_ADDR'] != $user_info['securityDNS'] && $_SERVER['REMOTE_ADDR'] != gethostbyname($user_info['securityDNS']))
			$error = 'dns_invalid';

		// any errors?
		if(!empty($error)) {
                        // may the user provide his password instead? if not, error.
                        if(empty($modSettings['vdns_altpwd']))
                                fatal_lang_error($error);

                        // in this case, this overrides the default setting
                        $modSettings['securityDisable'] = false;
                } elseif (!empty($modSettings['vdns_altpwd']))
                        $modSettings['securityDisable'] = true;
	}

</add before>



<edit file>
$sourcedir/Profile.php
</edit file>


<search for>
	global $newpassemail, $validationCode, $context, $settings, $sourcedir;
</search for>

<add after>
	global $ID_MEMBER;
</add after>


<search for>
		'registered' => empty($user_profile[$memID]['dateRegistered']) ? $txt[470] : strftime('%Y-%m-%d', $user_profile[$memID]['dateRegistered'] + ($user_info['time_offset'] + $modSettings['time_offset']) * 3600),
</search for>

<add after>
		'securityDNS' => empty($user_profile[$memID]['securityDNS']) ? '' : $user_profile[$memID]['securityDNS'],
</add after>


<search for>
		'registered' => empty($_POST['dateRegistered']) || $_POST['dateRegistered'] == '0001-01-01' ? $txt[470] : strftime('%Y-%m-%d', $_POST['dateRegistered']),
</search for>

<add after>
		'securityDNS' => empty($_POST['securityDNS']) ? '' : $_POST['securityDNS'],
</add after>


<search for>
		'pm_ignore_list',
</search for>

<add after>
		'securityDNS',
</add after>


<search for>
			$_POST['smileySet'] = '';
	}
</search for>

<add after>

	// validate security dns
	if (isset($_POST['securityDNS']))
	{
		// did it change?
		if($_POST['securityDNS'] != $old_profile['securityDNS']) {

			// the user NEEDS to be admin to do this, even for his own profile!!
			is_admin();

                        if($ID_MEMBER == $memID && !empty($old_profile['securityDNS'])) {
        			// no proxies allowed here!
                		if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
                			fatal_lang_error('dns_noprox');
                		// if the remote address does not equal the dns, kill.
                		if($_SERVER['REMOTE_ADDR'] != $old_profile['securityDNS'] && $_SERVER['REMOTE_ADDR'] != gethostbyname($old_profile['securityDNS']))
                			fatal_lang_error('dns_invalid');
                	}

                        // is it even valid?
			if(preg_match('/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/', $_POST['securityDNS']) != 1 && $_POST['securityDNS'] == gethostbyname($_POST['securityDNS']))
				$post_errors[] = 'invalid_dns';
			// first time we set this
			elseif($ID_MEMBER == $memID && empty($old_profile['securityDNS']) && $_SERVER['REMOTE_ADDR'] != $_POST['securityDNS'] && $_SERVER['REMOTE_ADDR'] != gethostbyname($_POST['securityDNS']))
				$post_errors[] = 'foreign_dns';
		}
	}
</add after>



<edit file>
$themedir/Profile.template.php
</edit file>


<search for>
										document.getElementById("additionalGroupsLink").style.display = "";
									// ]]></script>
								</td>
							</tr>';
	}

</search for>

<add after>
	if ($context['user']['is_admin'])
	{
		echo '
							<tr>
								<td colspan="2"><hr width="100%" size="1" class="hrcolor" /></td>
							</tr><tr>
								<td width="40%"><b', isset($context['modify_error']['invalid_dns']) || isset($context['modify_error']['foreign_dns']) ? ' style="color: red;"' : '', '>', $txt['sec_dns'], ': </b><div class="smalltext">(<a href="', $scripturl, '?action=helpadmin;help=what_is_dns" onclick="return reqWin(this.href);">', $txt['sec_expl'], '</a>)</div></td>
								<td><input type="text" name="securityDNS" size="60" maxlength="200" value="', $context['member']['securityDNS'], '" /></td>
								</td>
							</tr>';
	}

</add after>



<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('check', 'securityDisable'),
</search for>

<add after>
			array('check', 'vdns_enable'),
			array('check', 'vdns_altpwd'),
</add after>



<edit file>
$themedir/languages/Modifications.english.php
</edit file>


<search for>
// Version: 1.1; Modifications
</search for>

<add after>

$txt['vdns_enable'] = 'Enable admin DNS check (<b>careful!</b>)';
$txt['vdns_altpwd'] = 'Allow dns bypass by password';
$txt['dns_notset'] = 'No IP/DNS specified, contact some other administrator, or manually disable the DNS check in the database if there is none.';
$txt['dns_noprox'] = 'Admin interface access through proxy not allowed.';
$txt['dns_invalid'] = 'IP/DNS check for admin login failed.';

$txt['sec_dns'] = 'Security-DNS/IP';
$txt['sec_expl'] = 'What is this?';

$txt['profile_error_invalid_dns'] = 'The dns could not be resolved.';
$txt['profile_error_foreign_dns'] = 'The ip/dns did not match your ip.';
</add after>



<edit file>
$themedir/languages/Help.english.php
</edit file>


<search for>
$txt[1006] = 'Close window';
</search for>

<add after>
$helptxt['vdns_enable'] = 'If this is enabled, an additional check for the ip/dns will be required for admins to log into the admin panel. If the user\'s current IP does not match the ip/dns given in the profile, access is denied.<br /><br /><i>If you enable this and don\'t have at least one admin dns properly configured, you\'re going to face troubles logging in to the admin interface, so make sure you have at least one account with valid DNS!!</i><br /><br />You can get a dynamic DNS at <a href="http://no-ip.org">no-ip.org</a>, <a href="http://dyndns.org">DynDNS.org</a>, or several other places.<br /><br />Also, if this is enabled, proxy connections will not be allowed to access the admin interface, for additional security.<br /><br />If you check "Disable administration security", the dns check is still active, meaning that you can use the DNS check as a replacement for the password check.';
$helptxt['vdns_altpwd'] = 'Enabling this setting allows the user to <i>either</i> have the correct dns <i>or</i> provide her password to pass the security check. If this setting is enabled, the user will not be asked for a password if he passes dns test (regardless of the "Disable Administration Security" setting) but may provide it otherwise to still access the admin section.<br /><br />Use this if you are too lazy to type in your password on your own pc (and instead have it dns checked) but still want access from other places.<br /><br />This does not have any effect if DNS check is not enabled.';
$helptxt['what_is_dns'] = 'The security ip/dns is checked every admin-login, giving an error if it doesn\'t match the current ip of the user. This provides a more secure admin login.<br /><br />You can get a dynamic DNS at <a href="http://no-ip.org">no-ip.org</a>, <a href="http://dyndns.org">DynDNS.org</a>, or several other places.<br /><br />Ex.: "myusername.no-ip.org"<br />Ex.: "127.0.0.1"<br /><br />Note that if you want to change your dns setting, you will have to login from the one provided before, or have another admin change it!';
</add after>